function [ob] = MCMCRM(nmh, nmp, numit, A, sinit, drCov, pgeinit, pgminit, poeinit, pominit, Ginit, bLinit, bRinit)

% Constants

reRinit = 1;
rmRinit = 1/2;
rmLinit = 1/2;
reLinit = 0;
dinit   = 1;

if (nargin < 13), bRinit=0.5; end
if (nargin < 12), bLinit=0.5; end
if (nargin < 11), Ginit=1.5; end
if (nargin < 10), pominit=0.6; end
if (nargin < 9), poeinit=0.5; end
if (nargin < 8), pgminit=0.65; end
if (nargin < 7), pgeinit=0.65; end
if (nargin < 6), R = chol(diag([0.1, 0.1, 0.17, 0.17, 1, ones(1,nc * 2) * 0.2]/(3+nc))); end
if (nargin < 5), sinit=0; end


%%Initialization
nc = size(A, 1);
npar = 5 + 2 * nc;
R = chol(((2.4^2)/npar) * drCov);
periods = zeros(nc,1);

for i=1:nc
    periods(i,1) = size(A{i,1},2);
end
fprintf('Data is %i periods long \n', periods)

indp = zeros(nc,2);
indp(1,1) = 1;
indp(1,2) = periods(1,1);
if (nc>1)
    for  i = 2:nc
        indp(i,1) = sum(periods([1:(i-1)],1)) + 1;
        indp(i,2) = sum(periods([1:i],1));
    end
end


%need a matrix to hold to chain values
mchainGL = zeros(numit,9 + nc + 1);
mchainB = zeros(numit, nc*2);
mchainP = zeros(numit, sum(periods));

%need some starting values: use above

mchainB(1,:) = cat(2, ones(1,nc) * bLinit, ones(1,nc) * bRinit);
for i = 1:nc
    if (A{i,1}(1,1)==1)
        mchainB(1,i)=mchainB(1,nc+i)-0.01;
    else
        mchainB(1,i)=mchainB(1,nc+i)+0.01;
    end
end

%check inequalities here...
if(IneqCheck(pgeinit,pgminit,poeinit,pominit,Ginit,reRinit,rmRinit,rmLinit,reLinit,mchainB(1,1:(nc*2)),dinit,sinit) == 1)
    fprintf('Parameters ok \n')
else
    fprintf('WARNING: check Parameters \n')
end

currL = zeros(1,nc + 1);

for i = 1:nc
    currL(1,i) = LL(pgeinit,pgminit,poeinit,pominit,Ginit,reRinit,rmRinit,rmLinit,reLinit,mchainB(1,i),mchainB(1,nc + i),dinit,sinit,zeros(1,periods(i,1)),A{i,1});
end
currL(1, nc + 1)=sum(currL(1, 1:nc));
fprintf('Likelihood is %g initially \n',currL)


mchainGL(1,:) = [pgeinit,pgminit,poeinit,pominit,Ginit,rmRinit,rmLinit,dinit,sinit,currL];
mchainP(1,:) = zeros(1,sum(periods));



L1 = zeros(1,nc + 1);
fprintf('iteration: ')
%%begin the sampler
for i = 2:numit
    
    if (floor(i/1000)==(i/1000))
        fprintf(' %i,',i)
    end
    %most upto date state for each parameter
    currpge=mchainGL(i-1,1);
    currpgm=mchainGL(i-1,2);
    currpoe=mchainGL(i-1,3);
    currpom=mchainGL(i-1,4);
    
    currG =mchainGL(i-1,5);
    currrmR=mchainGL(i-1,6);
    currrmL=mchainGL(i-1,7);
    currd=mchainGL(i-1,8);
    currs=mchainGL(i-1,9);
    currL=mchainGL(i-1,10:(10+nc));
    
    currb = mchainB(i-1,:);
    currYex=mchainP(i-1,:);
    
    
    %All Parameters except Policies
    for h = 1:nmh
        propP = [currpge,currpgm,currpoe,currpom,currG,currb] + randn(1,npar) * R;
        if (IneqCheck(propP(1,1),propP(1,2),propP(1,3),propP(1,4),propP(1,5),reRinit,currrmR,currrmL,reLinit,propP(1,6:(5+nc*2)),currd,currs) == 1)
            for j = 1:nc
                L1(1, j) = LL(propP(1,1),propP(1,2),propP(1,3),propP(1,4),propP(1,5),reRinit,currrmR,currrmL,reLinit,propP(5+j),propP(5+nc+j),currd,currs,currYex(1,indp(j,1):indp(j,2)),A{j,1});
            end
            L1(nc+1) = sum(L1(1,1:nc));
            MHratio = exp(L1(1, nc+1) - (propP(1,5)) - currL(1, nc+1) + currG);
            alpha = min(1,MHratio);
            if (rand < alpha)
                currpge=propP(1,1);
                currpgm=propP(1,2);
                currpoe=propP(1,3);
                currpom=propP(1,4);
                currG=propP(1,5);
                currb=propP(1,6:(5+nc*2));
                currL=L1;
            end
        end
    end
    
    
    %x
    for Diter = 1:nmp
        for j = 1:nc
            for h = 1:periods(j,1)
                propexY = currYex(1,indp(j,1):indp(j,2));
                propexY(1,h) = 1-propexY(1,h);
                L1(1,j) = LL(currpge,currpgm,currpoe,currpom,currG,reRinit,currrmR,currrmL,reLinit,currb(1,j),currb(1,nc+j),currd,currs,propexY,A{j,1});
                Probnew=(exp(L1(1,j))/(exp(L1(1,j))+exp(currL(1,j))));
                if(rand < Probnew)
                    currYex(1,indp(j,1):indp(j,2)) = propexY;
                    currL(1,j)=L1(1,j);
                end
            end
        end
    end
    
    currL(1,nc+1) = sum(currL(1,1:nc));
    
    %update chain with new values
    mchainGL(i,:)= [currpge,currpgm,currpoe, currpom, currG,currrmR,currrmL,currd,currs,currL];
    mchainB(i,:)=currb;
    mchainP(i,:)=currYex;
end
ob = cat(2, mchainGL, mchainB, mchainP);

end
